
package de.ivu.elect.business.wahlvorschlag.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahlvorschlag.entity.Direktkandidat;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractDirektkandidatEdit {

  @Inject
  protected DirektkandidatDAO dao;

  @Inject
  protected DirektkandidatExtendedDAO extendedDao;

  public void delete(Direktkandidat entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Direktkandidat entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Direktkandidat entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Direktkandidat getAttachedEntity(Direktkandidat entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Direktkandidat getAttachedAndRefreshedEntity(Direktkandidat entity) {
    return dao.refresh(entity);
  }
}
